<component-section>
  <div slot="title">📈  Performanceonderzoek</div>
  <component-section>
    <div slot="title">Begrippenkader</div>
    <p class="bron">
      Systems Performance
      <cite data-id="6867189/VBGW22DZ" data-label="chapter" data-locator="1"></cite>
      <cite data-id="6867189/VBGW22DZ" data-label="chapter" data-locator="2"></cite> (optioneel, relevant voor OP)
      <cite data-id="6867189/VBGW22DZ" data-label="section" data-locator="5-5.4"></cite>
    </p>
    <!-- TODO: wat is performance efficiency? -->
    <p>
      <em class="term">Profiling</em> is het verzamelen van statistische informatie over voor performanceonderzoek
      relevante soorten gebeurtenissen terwijl een softwaresysteem loopt.
    </p>
    <ul>
      <li>
        <p>Gebeurtenissen binnen het systeem</p>
        <ul>
          <li>
            <p>Hoeveel geheugenallocaties</p>
          </li>
          <li>
            <p>Hoeveel threads</p>
          </li>
          <li>
            <p>Hoeveel geheugenruimte in gebruik</p>
          </li>
          <li>
            <p>...</p>
          </li>
        </ul>
      </li>
      <li>
        <p>Gebeurtenissen buiten het systeem</p>
        <ul>
          <li>
            <p>Hoeveel keer swapfile aangesproken?</p>
          </li>
          <li>
            <p>Hoeveel threads actief in totaal?p></p>
          </li>

          <li>
            <p>Hoeveel dataverkeer?</p>
          </li>
          <li>
            <p>Hoeveel stroomverbruik?</p>
          </li>
          <li>
            <p>...</p>
          </li>
        </ul>
      </li>
    </ul>
    <p>
      <em class="term">Benchmarking</em> houdt in performance testen in vergelijking met een bepaalde baseline
      (normniveau) en/of alternatieven.
    </p>
    <p>
      Microbenchmarking betekent dat de computationele taak kortlopend is. Dat is dus zelden een hele use-case of
      functionele test, maar vaker bijvoorbeeld een unit test of integratietest.
    </p>
    <p>
      <em class="term">Performance testing</em> is een verzamelbegrip. Om te <em>testen</em> heb je criteria nodig en
      een context (zoals de qas’en uit SKA). Dat maakt het verschil met performance engineering in brede zin. Je
      ontwikkelt niet (soms doelloos of prematuur), maar je bent vooral aan het onderzoeken.
    </p>
  </component-section>
  <component-section>
    <div slot="title">Onderzoeken</div>
    <component-section>
      <div slot="title">Reikwijdte (onderzoeksprojectgrenzen) en randvoorwaarden</div>
      <p>De fase in de softwarelevenscyclus waarbinnen je onderzoekt beïnvloedt welke methoden je toe kan passen:</p>
      <ul>
        <li>
          <p><em>Ontwikkelfase</em>: benchmarking.</p>
        </li>
        <li>
          <p><em>Onderhoudsfase en operationeel</em>: profiling.</p>
        </li>
      </ul>
      <p>Natuurlijk kan je ook beide fases meenemen, als dat binnen je onderzoeksopdracht past.</p>
      <p><em>Separation of concerns</em>: besturingssysteem versus de onderzochte softwaresystemen.</p>
      <p>Welke randvoorwaarden? Ga je uit van bepaalde hardware?</p>
      <p>
        Welke constraints (grenzen aan softwaresysteem) gelden? Hieruit kunnen hardware- en besturingssysteemgrenzen
        volgen.
      </p>
    </component-section>
    <component-section>
      <div slot="title">Welke componenten onderzoeken</div>
      <p>
        Afhankelijk van welke fase van de softwarelevenscyclus je wilt onderzoeken, kan je als aanknopingspunten de
        volgende zaken nemen:
      </p>
      <ul>
        <li>
          <p>Ontwikkeling</p>
          <ul>
            <li>
              <p>(Niet-performance) tests</p>
            </li>
          </ul>
        </li>
        <li>
          <p>Operationeel</p>
          <ul>
            <li>
              <p>Use-cases nabootsen als workload scenario.</p>
              <p>Networked apps (bijvoorbeeld webapps): profilen en monitoren van (productie)variant.</p>
            </li>
            <li>
              <p>Bouwstraat.</p>
            </li>
          </ul>
        </li>
      </ul>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Performance tests schrijven</div>
    <p>
      Kan al met simple timing info
      <a href="https://www.baeldung.com/junit-test-execution-time#intellij%20junit"
        >geproduceerd door bijvoorbeeld het JUnit test framework en/of IDE</a
      >.
    </p>
    <p>
      Kan nog beter met specifiek benchmarking framework (<em>harness</em>), zoals
      <a href="http://tutorials.jenkov.com/java-performance/jmh.html">JMH</a>. Voordelen:
    </p>
    <ul>
      <li>
        <p>
          Kan optimalisaties door compiler onder controle houden, waardoor ‘nutteloze’ broncode niet weggeoptimaliseerd
          word.
        </p>
      </li>
      <li>
        <p>Hanteert nauwkeurige timers.</p>
      </li>
      <li>
        <p>Herhaalt metingen automatisch, en geeft relevante statistieken (mediaan bijvoorbeeld).</p>
      </li>
    </ul>
  </component-section>
  <component-section>
    <div slot="title">Algoritmeanalyse versus andere vormen van performance onderzoek</div>
    <ul>
      <li>
        <p>Abstract versus concreet.</p>
      </li>
      <li>
        <p>Algemene waarheid (fundamenteel onderzoek) versus waarheid onder systeem (praktijkonderzoek).</p>
      </li>
      <li>
        <p>Schaalbaarheid versus exacte prestatie in praktijkscenario.</p>
      </li>
    </ul>
  </component-section>
  <component-section>
    <div slot="title">Relatie tussen prestatie-efficiëntie (‘performance’) en andere kwaliteitseigenschappen</div>
    <ul>
      <li>
        <p><em>Schaalbaarheid</em>: algoritmeanalyse nuttig!</p>
      </li>
      <li>
        <p><em>Onderhoudbaarheid</em>: hoe lang tests duren.</p>
      </li>
      <li>
        <p>
          <em>Gebruikersvriendelijkheid</em>: als gebruikers te lang moeten wachten denken ze dat ze iets niet goed doen
          of dat er een probleem is opgetreden.
        </p>
      </li>
      <li>
        <p><em>Kosten</em>: hoe inefficiënter hoe meer kosten. Dat tikt aan, zeker in een public cloudomgeving.</p>
      </li>
    </ul>
  </component-section>
  <component-section>
    <div slot="title">Scenario/workload ontwerpen om te onderzoeken</div>
    <p>Normale versus extreme scenario’s = gemiddelde geval versus slechtste geval én grootte invoerdata.</p>
    <p>Data speelt een cruciale rol, zeker bij algoritmeanalyse.</p>
    <p>Welke grootheid meet je? Geheugen versus looptijd?</p>
    <p>Referentiedataset (test inputs).</p>
  </component-section>
  <component-section>
    <div slot="title">Resultaten</div>
    <p>Ruwe meetgegevens versus rapportage.</p>
    <p>Watervaldiagram.</p>
    <p>Flame graph.</p>
    <p>Samenvattende statistieken versus profile (= detailstatistieken).</p>
  </component-section>
  <component-section>
    <div slot="title">Tips</div>
    <p>Gebruik de performance matras van Gregg.</p>
    <p>
      Begin met de eenvoudigste performance tests. Beter een compleet onderzoek dan een perfect maar incompleet
      onderzoek!
    </p>
    <p>
      Neem ook een eventueel <em>frontend</em> (webgebaseerde gebruikersinterface) mee. Verscheidene metrics in de
      developer tools van browser die te maken hebben met vertragingen in de GUI. Voel je in je onderzoek niet gebonden
      aan één programmeertaal, zoals waar de backend in geschreven is.
    </p>
    <p>
      Zoek naar gericht naar het gebruik van datastructuren, zeker die waarvan je al weet dat die niet efficiënt zijn
      (geïmplementeerd). Bijvoorbeeld
      <code class="lang-java">Stack</code> uit Java standard library.
    </p>
  </component-section>
</component-section>
